diff --git a/net/Makefile.objs b/net/Makefile.objs
index 5fa2f97..de06ebe 100644
--- a/net/Makefile.objs
+++ b/net/Makefile.objs
@@ -15,3 +15,4 @@ common-obj-$(CONFIG_VDE) += vde.o
 common-obj-$(CONFIG_NETMAP) += netmap.o
 common-obj-y += filter.o
 common-obj-y += filter-buffer.o
+common-obj-y += traffic-mirror.o
diff --git a/net/traffic-mirror.c b/net/traffic-mirror.c
new file mode 100644
index 0000000..bed915c
--- /dev/null
+++ b/net/traffic-mirror.c
@@ -0,0 +1,173 @@
+/*
+ * Copyright (c) 2016 HUAWEI TECHNOLOGIES CO., LTD.
+ * Copyright (c) 2016 FUJITSU LIMITED
+ * Copyright (c) 2016 Intel Corporation
+ *
+ * Author: Zhang Chen <zhangchen.fnst@cn.fujitsu.com>
+ *
+ * This work is licensed under the terms of the GNU GPL, version 2 or
+ * later.  See the COPYING file in the top-level directory.
+ */
+
+#include "net/filter.h"
+#include "net/net.h"
+#include "qemu-common.h"
+#include "qapi/qmp/qerror.h"
+#include "qapi-visit.h"
+#include "qom/object.h"
+#include "qemu/main-loop.h"
+#include "qemu/error-report.h"
+#include "trace.h"
+#include "sysemu/char.h"
+#include "qemu/iov.h"
+
+#define FILTER_TRAFFIC_MIRROR(obj) \
+    OBJECT_CHECK(MirrorState, (obj), TYPE_FILTER_TRAFFIC_MIRROR)
+
+#define TYPE_FILTER_TRAFFIC_MIRROR "traffic-mirror"
+
+typedef struct MirrorState {
+    NetFilterState parent_obj;
+    char *outdev;
+    CharDriverState *chr_out;
+
+} MirrorState;
+
+static ssize_t traffic_mirror_send(NetFilterState *nf,
+                                   const struct iovec *iov,
+                                   int iovcnt)
+{
+    MirrorState *s = FILTER_TRAFFIC_MIRROR(nf);
+    ssize_t ret = 0;
+    ssize_t size = 0;
+    char *buf;
+
+    size = iov_size(iov, iovcnt);
+    if (!size) {
+        return 0;
+    }
+
+    buf = g_malloc0(size);
+    iov_to_buf(iov, iovcnt, 0, buf, size);
+    ret = qemu_chr_fe_write(s->chr_out, (uint8_t *)&size, sizeof(size));
+    if (ret < 0) {
+        g_free(buf);
+        return ret;
+    }
+
+    ret = qemu_chr_fe_write(s->chr_out, (uint8_t *)buf, size);
+    g_free(buf);
+    return ret;
+}
+
+static ssize_t traffic_mirror_receive_iov(NetFilterState *nf,
+                                         NetClientState *sender,
+                                         unsigned flags,
+                                         const struct iovec *iov,
+                                         int iovcnt,
+                                         NetPacketSent *sent_cb)
+{
+    /*
+     * We copy and mirror packet to outdev,
+     * then put back the packet.
+     */
+    ssize_t ret = 0;
+
+    ret = traffic_mirror_send(nf, iov, iovcnt);
+    if (ret < 0) {
+        error_report("traffic_mirror_send failed");
+    }
+
+    return 0;
+}
+
+static void traffic_mirror_cleanup(NetFilterState *nf)
+{
+    MirrorState *s = FILTER_TRAFFIC_MIRROR(nf);
+
+    if (s->chr_out) {
+        qemu_chr_fe_release(s->chr_out);
+    }
+}
+
+static void traffic_mirror_setup(NetFilterState *nf, Error **errp)
+{
+    MirrorState *s = FILTER_TRAFFIC_MIRROR(nf);
+
+    if (!s->outdev) {
+        error_setg(errp, "filter traffic mirror needs 'outdev' "
+                "property set!");
+        return;
+    }
+
+    s->chr_out = qemu_chr_find(s->outdev);
+    if (s->chr_out == NULL) {
+        error_set(errp, ERROR_CLASS_DEVICE_NOT_FOUND,
+                  "Device '%s' not found", s->outdev);
+        return;
+    }
+
+    if (qemu_chr_fe_claim(s->chr_out) != 0) {
+        error_setg(errp, QERR_DEVICE_IN_USE, s->outdev);
+        return;
+    }
+}
+
+static void traffic_mirror_class_init(ObjectClass *oc, void *data)
+{
+    NetFilterClass *nfc = NETFILTER_CLASS(oc);
+
+    nfc->setup = traffic_mirror_setup;
+    nfc->cleanup = traffic_mirror_cleanup;
+    nfc->receive_iov = traffic_mirror_receive_iov;
+}
+
+static char *traffic_mirror_get_outdev(Object *obj, Error **errp)
+{
+    MirrorState *s = FILTER_TRAFFIC_MIRROR(obj);
+
+    return g_strdup(s->outdev);
+}
+
+static void
+traffic_mirror_set_outdev(Object *obj, const char *value, Error **errp)
+{
+    MirrorState *s = FILTER_TRAFFIC_MIRROR(obj);
+
+    g_free(s->outdev);
+    s->outdev = g_strdup(value);
+    if (!s->outdev) {
+        error_setg(errp, "filter traffic mirror needs 'outdev' "
+                "property set!");
+        return;
+    }
+}
+
+static void traffic_mirror_init(Object *obj)
+{
+    object_property_add_str(obj, "outdev", traffic_mirror_get_outdev,
+                            traffic_mirror_set_outdev, NULL);
+}
+
+static void traffic_mirror_fini(Object *obj)
+{
+    MirrorState *s = FILTER_TRAFFIC_MIRROR(obj);
+
+    g_free(s->outdev);
+}
+
+static const TypeInfo traffic_mirror_info = {
+    .name = TYPE_FILTER_TRAFFIC_MIRROR,
+    .parent = TYPE_NETFILTER,
+    .class_init = traffic_mirror_class_init,
+    .instance_init = traffic_mirror_init,
+    .instance_finalize = traffic_mirror_fini,
+    .instance_size = sizeof(MirrorState),
+};
+
+static void register_types(void)
+{
+    type_register_static(&traffic_mirror_info);
+}
+
+type_init(register_types);
diff --git a/qemu-options.hx b/qemu-options.hx
index 0eea4ee..6fd2d46 100644
--- a/qemu-options.hx
+++ b/qemu-options.hx
@@ -3670,6 +3670,11 @@ queue @var{all|rx|tx} is an option that can be applied to any netfilter.
 @option{tx}: the filter is attached to the transmit queue of the netdev,
              where it will receive packets sent by the netdev.
 
+@item -object traffic-mirror,id=@var{id},netdev=@var{netdevid},outdev=@var{chardevid}[,queue=@var{all|rx|tx}]
+
+traffic-mirror on netdev @var{netdevid},mirror net packet to outdev.
+queue @var{all|rx|tx} is an option that can be applied to traffic-mirror.
+
 @item -object filter-dump,id=@var{id},netdev=@var{dev},file=@var{filename}][,maxlen=@var{len}]
 
 Dump the network traffic on netdev @var{dev} to the file specified by
diff --git a/vl.c b/vl.c
index 8dc34ce..413d73a 100644
--- a/vl.c
+++ b/vl.c
@@ -2838,7 +2838,8 @@ static bool object_create_initial(const char *type)
      * they depend on netdevs already existing
      */
     if (g_str_equal(type, "filter-buffer") ||
-        g_str_equal(type, "filter-dump")) {
+        g_str_equal(type, "filter-dump") ||
+        g_str_equal(type, "traffic-mirror")) {
         return false;
     }
 